<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
            <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
            <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
            <!-- Import Datatable sau jquery -->
            <!-- Import them style bootstrap cho datatable -->
            <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
            <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
            <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
        <title>Task 23B.40</title>
    </head>
    <style>
        .background-image {
            background-image: url(LuckyDiceImages/ob_cd446b_black-bg-casinodice.jpg);
            min-height: 100px;
            margin: 5px;
        }
    </style>
    <body>
        <div class="container-fluid background-image">
            ImgDice
        </div>
        <div class="container">
            <div class="row">
                <div class="col-sm-5">
                    <div class="row">
                        <div class="col-sm-12 form-group">
                            <h4>
                                Nhập thông tin của bạn
                            </h4>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-username"> 
                                Username
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-username" type="text" class="form-control" type="text" placeholder="username....">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-firstname"> 
                                Firstname
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-firstname" type="text" class="form-control" type="text" placeholder="firstname....">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-lastname"> 
                                Lastname
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-lastname" type="text" class="form-control" type="text" placeholder="lastname....">
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <button class="btn btn-success" onclick="onBtnNemClick()">Ném</button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice_noun_002_10624.jpg" alt="">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <p id="p-thongbao">Xin Chào</p>
                        </div>
                    </div>
                </div>
                <div class="col-sm-3">
                    <div class="row">
                        <div class="col-sm-12 text-center form-group">
                            <p>
                                Voucher
                            </p>
                            <p id="p-id">
                                ID:0000
                            </p>
                            <p id="p-discount">
                                0%
                            </p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="co-sm-12 text-center form-group">
                            <img id="img-prize" src="LuckyDiceImages/no-present.jpg" class="img-thumbnail" alt="">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 text-center form-group">
                   <button onclick="onBtnDiceHistoryClick()" class="btn btn-success">Dice Hitory</button>
                   <button onclick="onBtnVoucherHistoryClick()" class="btn btn-info">Voucher Hitory</button>
                   <button onclick="onBtnPrizeHistoryClick()" class="btn btn-info">Present Hitory</button>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                   <table id="history-dice-table" class="table table-striped table-hover ">
                       <thead>
                        <tr>
                            <th>
                                Lượt
                            </th>
                            <th id="name-table">
                                Dice
                            </th>
                        </tr>
                       </thead>
                       <tbody>
                       </tbody>
                   </table>
                </div>
            </div>
        </div>
    </body>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

        const gBASE_URL = "/devcamp-lucky-dice";

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //Hàm xữ lý nút ném
        var onBtnNemClick = () => {
            "use strict";
            //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
            var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCheck về true còn không thì cảnh báo và trả vCheck về false
            var vCheck = validateDaTaObject(vUserDataObject);
            console.log(vCheck);
            //Nếu vCheck = true thì consolelog ra "Dữ liệu hợp lệ" nếu false thì consolelog ra "Dữ liệu không hợp lệ"
            if (vCheck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAjaxCreateDataDice(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        //Hàm nút nhấn Dice History
        var onBtnDiceHistoryClick = () => {
            "use strict"
            console.log("Nút Dice History được ấn");
             //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
             var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCheckvề true còn không thì cảnh báo và trả vCheck về false
            var vCheck = validateDaTaObject(vUserDataObject);
            if (vCheck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAPIDataHistoryDice(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        //Hàm nút nhấn Voucher History
        var onBtnVoucherHistoryClick = () => {
            "use strict"
            console.log("Nút Voucher History được ấn");
             //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
             var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCheckvề true còn không thì cảnh báo và trả vCheck về false
            var vCheck = validateDaTaObject(vUserDataObject);
            if (vCheck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAPIDataHistoryVoucher(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        //Hàm nút nhấn Prize History
        var onBtnPrizeHistoryClick = () => {
            "use strict"
            console.log("Nút Voucher History được ấn");
             //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
             var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCheckvề true còn không thì cảnh báo và trả vCheck về false
            var vCheck = validateDaTaObject(vUserDataObject);
            if (vCheck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAPIDataHistoryPrize(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm xóa hết phần tử row trong mảng 
        var refreshDiceHistoryTable = () => {
            "use strict"
            var vTable = document.getElementById("history-dice-table");
            while (vTable.rows.length > 1) {
                vTable.deleteRow(1);
            }
        }
        
        //Hàm ghi già trị dice history ra table
         var writeObjectHistoryToTable = (paramData) => {
            "use strict";
            refreshDiceHistoryTable();
            const vEND_OF_ROW = -1;
            const vCOLUMM_OF_TURN = 0;
            const vCOLUMM_OF_OBJECT = 1;
            var vTableDiceHistoryElement = document.getElementById("history-dice-table");
            var vTable = vTableDiceHistoryElement.getElementsByTagName("tbody")[0];
            if (paramData.diceHistory) {
                $("#name-table").text("Dice");
                for (var bIndex = 0 ; bIndex < paramData.diceHistory.length; bIndex ++) {
                var vDiceHistory = paramData.diceHistory[bIndex].dice;
                var vRow = vTable.insertRow(vEND_OF_ROW);
                var vCellTurn = vRow.insertCell(vCOLUMM_OF_TURN);
                var vCellDice = vRow.insertCell(vCOLUMM_OF_OBJECT);
                vCellTurn.innerHTML = bIndex + 1;
                vCellDice.innerHTML = vDiceHistory;
            }
            }
            if (paramData.prizeHistory) {
                $("#name-table").text("Prize");
                debugger;
                for (var bIndex = 0 ; bIndex < paramData.prizeHistory.length; bIndex ++) {
                var vPrizeHistory = paramData.prizeHistory[bIndex].prize[0].name;
                var vRow = vTable.insertRow(vEND_OF_ROW);
                var vCellTurn = vRow.insertCell(vCOLUMM_OF_TURN);
                var vCellPrize = vRow.insertCell(vCOLUMM_OF_OBJECT);
                vCellTurn.innerHTML = bIndex + 1;
                vCellPrize.innerHTML = vPrizeHistory;
            }
            }
            if (paramData.voucherHistory) {
                $("#name-table").text("Voucher");
                for (var bIndex = 0 ; bIndex < paramData.voucherHistory.length; bIndex ++) {
                var vVoucherHistory = paramData.voucherHistory[bIndex].voucher;
                var vRow = vTable.insertRow(vEND_OF_ROW);
                var vCellTurn = vRow.insertCell(vCOLUMM_OF_TURN);
                var vCellVoucher = vRow.insertCell(vCOLUMM_OF_OBJECT);
                vCellTurn.innerHTML = bIndex + 1;
                if (vVoucherHistory.length == 0) {
                    vCellVoucher.innerHTML = 0;
                }
                else{
                    vCellVoucher.innerHTML = vVoucherHistory[0].discount;
                }
            }
            }
         }

        
        //Hàm api object của dice history
        var callAPIDataHistoryDice = (paramDataObject) => {
            
            "use strict";
            var vUserName = paramDataObject.username;
            $.ajax({
                url:gBASE_URL + "/dice-history?username=" + vUserName,
                type:"GET",
                dataType:"json",
                success:(res) => {
                    writeObjectHistoryToTable(res);
                },
                error:(ajax) => {
                    alert(ajax.responseText);
                }
            })
        }
        //Hàm api object của dice history
        var callAPIDataHistoryPrize = (paramDataObject) => {
            "use strict";
            var vUserName = paramDataObject.username;
            $.ajax({
                url:gBASE_URL + "/prize-history?username=" + vUserName,
                type:"GET",
                dataType:"json",
                success:(res) => {
                    writeObjectHistoryToTable(res);
                },
                error:(ajax) => {
                    alert(ajax.responseText);
                }
            })
        }
        //Hàm api object của dice history
        var callAPIDataHistoryVoucher = (paramDataObject) => {
            "use strict";
            var vUserName = paramDataObject.username;
            $.ajax({
                url:gBASE_URL + "/voucher-history?username=" + vUserName,
                type:"GET",
                dataType:"json",
                success:(res) => {
                    console.log(res);
                    writeObjectHistoryToTable(res);
                },
                error:(ajax) => {
                    alert(ajax.responseText);
                }
            })
        }
        //Hiển thị prizes nếu có
        var changePrizesPresent = (paramPrize) => {
            "use strict";
            var vImgPrize = $("#img-prize");
            var vPrize = paramPrize;
            if (vPrize) {
                switch(vPrize.name) {
                case "Mũ":
                $("#img-prize").attr("src","LuckyDiceImages/hat.jpg");
                    break;
                case "Áo":
                $("#img-prize").attr("src","LuckyDiceImages/t-shirt.png");
                    break;
                case "Ô tô":
                $("#img-prize").attr("src","LuckyDiceImages/car.jpg");
                    break; 
                case "Xe máy":
                $("#img-prize").attr("src","LuckyDiceImages/xe_may.png");
                    break;
            }
            } else {
                $("#img-prize").attr("src","LuckyDiceImages/no-present.jpg");
            }
        }
        
        //Hàm ghi ra voucher
        var changeVoucherID = (paramVoucher) => {
            "use strict";
            var vPVoucherId = $("#p-id");
            var vPVoucherDiscount= $("#p-discount");
            var vVoucher = paramVoucher;
            if (vVoucher == null) {
                vPVoucherId.html("ID:0000");
                vPVoucherDiscount.html("0%");
            } else {
                var vVoucherId = paramVoucher.code;
                var vVoucherDiscount = paramVoucher.discount;
                vPVoucherId.html("ID:" +vVoucherId);
                vPVoucherDiscount.html(vVoucherDiscount + "%");
            }
        }

        //Hàm ghi ra thông báo
        var changeNotification =(paramDIce) => {
            "use strict";
            var vPNotification = $("#p-thongbao");
            if (paramDIce < 4) {
                vPNotification.html("Chúc bạn may mắn lần sau !!!");
            } else {
                vPNotification.html( "Xin chúc bạn hãy chơi tiếp !!!");
            }
        }
        
        //Hàm chuyển đổi ảnh dựa vào số xúc xắc
        var changeImgDiceWithResult = (paramDiceObject) => {
            "use strict";
            var vDice = paramDiceObject;
            if (vDice == 1) {
                $("#img-dice").attr("src","LuckyDiceImages/1.png" );
            } else  if (vDice == 2) {
                $("#img-dice").attr("src","LuckyDiceImages/2.png" );
            } else  if (vDice == 3) {
                $("#img-dice").attr("src","LuckyDiceImages/3.png" );
            } else  if (vDice == 4) {
                $("#img-dice").attr("src","LuckyDiceImages/4.png" );
            } else  if (vDice == 5) {
                $("#img-dice").attr("src","LuckyDiceImages/5.png" );
            } else  if (vDice == 6) {
                $("#img-dice").attr("src","LuckyDiceImages/6.png" );
            }
        };

        //Gọi server lấy responseText
        var callAjaxCreateDataDice = (paramDataObject) => {
            "use strict";
          $.ajax({
           url:gBASE_URL + "/dice",
           type:"POST",
           contentType:"application/json",
           data:JSON.stringify(paramDataObject),
           success:(res) =>{
            console.log(res)
            changeImgDiceWithResult(res.dice);
            changePrizesPresent(res.prize);
            console.log(res.prize);
            changeVoucherID(res.voucher);
            changeNotification(res.dice);
           },
           error:(ajax)=>{
            alert(ajax.responseText);
           }
          })
        }
        //Hàm kiểm tra dữ liệu
        var validateDaTaObject = (paramDataObject) => {
            "use strict";
            var vResult = true;
            var vUsername = paramDataObject.username.trim();
            var vFirstname = paramDataObject.firstname.trim();
            var vLastname = paramDataObject.lastname.trim();
            if (vUsername == "") {
                alert("Chưa nhập username");
                vResult = false;
            } else if (vFirstname == "") {
                alert("Chưa nhập firstname");
                vResult = false;
            } else if ( vLastname == "") {
                alert("Chưa nhập lastname");
                vResult = false;
            }
            return vResult;
        }

        //Hàm lấy thông tin input chuyền vào hướng đối tượng vUserDataObject
        var getDataFormInput = () => {
            "use strict";
            var vUserDataObject = {
                username: "",
                firstname: "",
                lastname: ""
            }
            vUserDataObject.username = $("#input-username").val();
            vUserDataObject.firstname = $("#input-firstname").val();
            vUserDataObject.lastname = $("#input-lastname").val();

            return vUserDataObject;
        }
    </script>
</html>